CREATE OR ALTER procedure LOAD_MEDP_POL (
    N_PP integer not null,
    S_POL char(16),
    N_POL char(16),
    LPU_OGRN char(15),
    DATA_NL date,
    DATA_OL date,
    KOD_D char(7),
    SUM_L numeric(11,2),
    POLIS char(4),
    DATE_N date)
returns (
    APP smallint,
    MEDP_ID integer)
as
declare variable SMO_OGRN char(15);
begin
app=0;
select s.ogrn from smo s where s.smo_id=:polis into :smo_ogrn;
if (not exists (select m.n_pp from medp m where m.n_pp=:n_pp and m.l_ogrn=:lpu_ogrn and m.type_h='5' and
                m.data_nl=:data_nl and m.data_ol=:data_ol and m.kod_d=:kod_d)) then
begin
 medp_id=next value for gen_medp;
 insert into medp (id,n_pp,s_pol,n_pol,l_ogrn,type_h,data_nl,data_ol,kod_d,sum_l,s_ogrn,dat_n)
 values (:medp_id,:n_pp,:s_pol,:n_pol,:lpu_ogrn,'5',:data_nl,:data_ol,:kod_d,:sum_l,:smo_ogrn,:date_n);
 app=1;
end
end
@

CREATE OR ALTER procedure LOAD_MEDP_STAC (
    N_PP integer not null,
    S_POL char(16),
    N_POL char(16),
    LPU integer,
    TYPE_H TYPE_H,
    DATA_NL date,
    DATA_OL date,
    KOD_D char(7),
    SUM_L numeric(11,2),
    POLIS char(4),
    DATE_N date)
returns (
    APP smallint,
    MEDP_ID integer)
as
declare variable LPU_OGRN char(15);
declare variable SMO_OGRN char(15);
begin
app=0;
select l.ogrn from lpu l where l.lpu_id=:lpu into :lpu_ogrn;
 select s.ogrn from smo s where s.smo_id=:polis into :smo_ogrn;
if (not exists (select m.n_pp from medp m where m.n_pp=:n_pp and m.l_ogrn=:lpu_ogrn and m.type_h=:type_h and
                m.data_nl=:data_nl and m.data_ol=:data_ol and m.kod_d=:kod_d)) then
begin
 medp_id=next value for gen_medp;
 insert into medp (id,n_pp,s_pol,n_pol,l_ogrn,type_h,data_nl,data_ol,kod_d,sum_l,s_ogrn,dat_n)
 values (:medp_id,:n_pp,:s_pol,:n_pol,:lpu_ogrn,:type_h,:data_nl,:data_ol,:kod_d,:sum_l,:smo_ogrn,:date_n);
 app=1;
end
end
@

CREATE OR ALTER procedure LOAD_SMO2 (
    N_PP integer,
    N_ID integer,
    S_POL char(16),
    N_POL char(16),
    L_OGRN char(15),
    TYPE_H TYPE_H,
    KOD_D char(7),
    DATA_NL date,
    DATA_OL date,
    SUM_L numeric(15,2))
returns (
    ERR char(1),
    ERR1 char(1),
    ERR2 char(1),
    MEDP_ID integer)
as
begin
  err='0';err1='0';err2='0';
  if (exists(select e.n_pp from enter_smo e where e.n_pp=:n_pp)) then
  begin
   medp_id=next value for gen_medp;
   if (not exists(select m.id from medp m where m.n_id=:n_id)) then
    insert into medp (id,n_pp,s_pol,n_pol,l_ogrn,type_h,kod_d,data_nl,data_ol,sum_l,n_id)
    values (:medp_id,:n_pp,:s_pol,:n_pol,:l_ogrn,:type_h,:kod_d,:data_nl,:data_ol,:sum_l,:n_id);
   else err2='1';
  end else err1='1';
  if ((err1='1') or (err2='1')) then err='1';
  suspend;
end
@



DROP INDEX MEDP;
@

CREATE UNIQUE INDEX MEDP
ON MEDP (N_PP,L_OGRN,TYPE_H,DATA_NL,DATA_OL,KOD_D);
@