CREATE OR ALTER procedure CHECK_OMS
returns (
    FIO char(50),
    MONTHS char(15),
    YEARS smallint,
    ERR_TYPE char(1),
    LPU_NAME varchar(50),
    DATA_NL date,
    DATA_OL date,
    KOD_D char(7),
    SMO_NAME varchar(50),
    MON_NUM integer,
    TYPE_H varchar(45),
    SUMM numeric(15,2))
as
begin
 for select trim(e.fam)||' '||substring(e.im from 1 for 1)||'.'||substring(e.ot from 1 for 1)||'.',
     ms.name,e.years,l.name,m.data_nl,m.data_ol,m.kod_d,s.name,m.months,mt.naim,m.sum_l from medp m
  join enter_fss e on m.n_pp=e.id
  left join months ms on m.months=ms.id
  left join lpu l on l.ogrn=m.l_ogrn
  left join smo s on s.ogrn=m.s_ogrn
  left join medp_t mt on mt.id=m.type_h
 where (not m.sum_s is null) and m.sum_s<>m.sum_l
 into :fio,:months,:years,:lpu_name,:data_nl,:data_ol,:kod_d,:smo_name,:mon_num,:type_h,:summ do
 begin
  err_type='1';
  suspend;
 end

 for select trim(e.fam)||' '||substring(e.im from 1 for 1)||'.'||substring(e.ot from 1 for 1)||'.',
     ms.name,e.years,l.name,m.data_nl,m.data_ol,m.kod_d,s.name,m.months,mt.naim,m.sum_l from medp m
  join enter_fss e on m.n_pp=e.id
  left join months ms on m.months=ms.id
  left join lpu l on l.ogrn=m.l_ogrn
  left join smo s on s.ogrn=m.s_ogrn
  left join medp_t mt on mt.id=m.type_h
 where (m.sum_s is null) and (not m.smo_upload is null)
 into :fio,:months,:years,:lpu_name,:data_nl,:data_ol,:kod_d,:smo_name,:mon_num,:type_h,:summ do
 begin
  err_type='2';
  suspend;
 end

end
@
