CREATE OR ALTER procedure LOAD_SMOANSW (
    N_ID integer,
    N_ST char(10),
    D_ST date,
    SUM_S numeric(15,2),
    LPU_REMOVE smallint)
returns (
    ERR char(1),
    ERR1 char(1),
    ERR2 char(1),
    ERR3 char(1))
as
begin
  err='0';err1='0';err2='0';err3='0';
  if (exists(select m.id from medp m where m.id=:n_id)) then
  begin
   if (lpu_remove=0) then
    begin
     if ((n_st is null) or (trim(n_st)=''))  then err2='1';
     if (d_st is null) then err3='1';
    end
   if ((err2='0') and (err3='0')) then
    begin
     update medp
      set n_st=:n_st,
          d_st=:d_st,
          sum_s=:sum_s,
          lpu_remove=:lpu_remove
      where id=:n_id;
    end
  end else err1='1';
  if ((err1='1') or (err2='1') or (err3='1')) then err='1';
  suspend;
end
@


CREATE OR ALTER trigger medp_biu0 for medp
active before insert or update position 0
AS
begin
 new.s_pol=trim(new.s_pol);
 new.n_pol=trim(new.n_pol);
 if (new.dat_n='30.12.1899') then new.dat_n=null;
 if (new.d_st='30.12.1899') then new.d_st=null;
end
@

CREATE OR ALTER procedure CHECK_OMS
returns (
    FIO char(50),
    MONTHS char(15),
    YEARS smallint,
    ERR_TYPE char(1),
    LPU_NAME varchar(50),
    DATA_NL date,
    DATA_OL date,
    KOD_D char(7),
    SMO_NAME varchar(50),
    MON_NUM integer,
    TYPE_H varchar(45),
    SUMM numeric(15,2))
as
begin
 for select trim(e.fam)||' '||substring(e.im from 1 for 1)||'.'||substring(e.ot from 1 for 1)||'.',
     ms.name,e.years,l.name,m.data_nl,m.data_ol,m.kod_d,s.name,m.months,mt.naim,m.sum_l from medp m
  join enter_fss e on m.n_pp=e.id
  left join months ms on m.months=ms.id
  left join lpu l on l.ogrn=m.l_ogrn
  left join smo s on s.ogrn=m.s_ogrn
  left join medp_t mt on mt.id=m.type_h
 where (not m.sum_s is null) and m.sum_s<>m.sum_l and m.lpu_remove=0
 into :fio,:months,:years,:lpu_name,:data_nl,:data_ol,:kod_d,:smo_name,:mon_num,:type_h,:summ do
 begin
  err_type='1';
  suspend;
 end

 for select trim(e.fam)||' '||substring(e.im from 1 for 1)||'.'||substring(e.ot from 1 for 1)||'.',
     ms.name,e.years,l.name,m.data_nl,m.data_ol,m.kod_d,s.name,m.months,mt.naim,m.sum_l from medp m
  join enter_fss e on m.n_pp=e.id
  left join months ms on m.months=ms.id
  left join lpu l on l.ogrn=m.l_ogrn
  left join smo s on s.ogrn=m.s_ogrn
  left join medp_t mt on mt.id=m.type_h
 where (m.sum_s is null) and (not m.smo_upload is null)
 into :fio,:months,:years,:lpu_name,:data_nl,:data_ol,:kod_d,:smo_name,:mon_num,:type_h,:summ do
 begin
  err_type='2';
  suspend;
 end

end
@






